﻿using System;
using Plux;
using UILibrary;


  public class ConsoleUC : ShellControl {

    public new event CommandEventHandler CommandEntered;

    private delegate void WriteDelegate(string text, bool newline);
    private readonly WriteDelegate writeDelegate;


    public ConsoleUC() {
      writeDelegate = Write;
    }

    protected override void OnCommandEntered(string command) {
      if (CommandEntered != null) {
        CommandEntered(this, new CommandEventArgs(command));
      }
    }

    public void Write(string text, params object[] args) {
      Write(string.Format(text, args), false);
    }

    public void WriteLine(string text, params object[] args) {
      Write(string.Format(text, args), true);
    }

    void Write(string text, bool newline) {
      if (IsDisposed) {
        return;
      }
      if (InvokeRequired) {
        Invoke(writeDelegate, text, newline);
      } else {
        WriteText(text);
        if (newline) {
          WriteText(Environment.NewLine);
          PrintPrompt();
        }
        if (!Focused) {
          Focus();
        }
      }
    } 
  }

