using System;
using System.Drawing;
using System.Windows.Forms;
using Plux;

internal delegate Image ImageProvider();

internal partial class Display : UserControl {
    private readonly ImageProvider GetImage;

    internal IFlipForm flipFormParent;

    public Display(ImageProvider imageProvider) {
        GetImage = imageProvider;
        Application.EnableVisualStyles();
        InitializeComponent();
    }

    private void flip_Click(object sender, EventArgs e) {
        if (flipFormParent == null) {
            return;
        }
        if (IsSlowEffectEnabled()) {
            flipFormParent.FlipSlow();
        } else {
            flipFormParent.Flip();
        }
    }

    private bool IsSlowEffectEnabled() {
        return (ModifierKeys & Keys.Shift) != 0;
    }

    protected override void OnPaint(PaintEventArgs e) {
        pictureBox.Picture = GetImage();
        base.OnPaint(e);
    }
}