﻿using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace Plux.Framework {
  public class Path {
    public class Connection {
      private readonly PlugInfo plug;
      private readonly SlotInfo slot;

      public Connection(PlugInfo plug, SlotInfo slot) {
        this.plug = plug;
        this.slot = slot;
      }

      public SlotInfo Slot { get { return slot; } }
      public PlugInfo Plug { get { return plug; } }
    }

    private ReadOnlyCollection<Connection> path;

    public Path(Connection connection) : this(connection, null) {}

    public Path(Connection connection, Path path) {
      List<Connection> p = new List<Connection>();
      p.Add(connection);
      if (path != null) {
        p.AddRange(path.path);
      }
      this.path = new ReadOnlyCollection<Connection>(p);
    }

    public IList<Connection> Connections { get { return path; } }
  }
}